/*======================================================================
                      ADJINFOWR()

Adjacency info write (only for 2-space).
======================================================================*/
#include "saclib.h"
#include "qepcad.h"
#include <stdio.h>

void ADJINFOWR()
{
       Word Cp,C,c,M,x,y, xm, ym, d, i,j,jm, A, A1, T, A11, t, y0, y1, x0;

Step1: /* LaTeX preamble. */
       SWRITE("\n\n%=======================================================\n");
       SWRITE("\\documentstyle{article}\n");
       SWRITE("\\pagestyle{empty}\n");
       SWRITE("\\topmargin=0in\n");
       SWRITE("\\headheight=0.0cm\n");
       SWRITE("\\headsep=0.0cm\n");
       SWRITE("\\textheight=22.13cm\n");
       SWRITE("\\oddsidemargin=0in\n");
       SWRITE("\\evensidemargin=0in\n");
       SWRITE("\\textwidth=8in\n");
       SWRITE("\\begin{document}\n\n\n");

Step2: /* Projection factors and projection polys. */
       SWRITE("\\begin{verbatim}\n\n");
       SWRITE("========== Projection Factors ============\n\n");
       IPLLDWR(GVVL,GVPF); SWRITE("\n");  
       SWRITE("========== Projection Polys ==============\n\n");
       IPLLDWR(GVVL,GVPJ); SWRITE("\n\n");
       SWRITE("\\end{verbatim}\n");
       SWRITE("\\clearpage\n\n\n");

Step3: /* Compute the layout parameters. */
       d = 7;
       d = 7;

       xm = d * (LENGTH(LELTI(GVPC,CHILD))-1);

       jm = 0;
       Cp = LELTI(GVPC,CHILD);
       while (Cp != NIL)
         {
         ADV(Cp,&C,&Cp);
         j = LENGTH(LELTI(C,CHILD));
         if (j > jm)
            jm = j;
         }
       ym = d * (jm-1);

Step4: /* Write out each lines. */
       SWRITE("\\tiny\n");
       SWRITE("\\settowidth{\\unitlength}{W}\n");
       SWRITE("\\begin{figure}[t]\n");
       SWRITE("\\begin{picture}(");
       GWRITE(xm); CWRITE(','); GWRITE(ym);
       SWRITE(")(0,0)\n");

       x = 0;
       i = 0;
       Cp = LELTI(GVPC,CHILD);
       while (Cp != NIL)
         {
         ADV(Cp,&C,&Cp);
         y = 0;
         i = i + 1;
         j = 0;
         C = LELTI(C,CHILD);
         while (C != NIL)
           {
           ADV(C,&c,&C);
           j = j + 1;
           
           SWRITE("\\put("); GWRITE(x); CWRITE(','); GWRITE(y); SWRITE("){");

           if (EVEN(i) && EVEN(j)) 
              SWRITE("\\framebox{");

           if (EVEN(j))
              SWRITE("\\shortstack{");

           SIGNLWR(FIRST(LELTI(c,SIGNPF))); 
           if (EVEN(j))
             {
             M = LELTI(c,MULSUB);
             SWRITE("\\\\");
             LWRITE(M); 
             }

           if (EVEN(j))
              SWRITE("}");

           if (EVEN(i) && EVEN(j))
             SWRITE("}");

           SWRITE("}\n");
           y = y + d;
           }
         SWRITE("\n");
         x = x + d;
         }

Step5: /* Compute adjacencies. */
       T = ACLOCK();
       A = ADJ2(LELTI(GVPC,CHILD));
       T = ACLOCK() - T;

Step6: /* Draw the branches. */
       t = 1;
       x0 = -1;
       while (A != NIL)
         {
         ADV(A,&A1,&A);
         t = -t;
         y1 = 1;
         y0 = 1;
         if (t == -1) x0 = x0 + 2;
         while (A1 != NIL)
           {
           ADV(A1,&A11,&A1);
           for (i=1; i <= A11; i++)
             {
             SWRITE("\\put(");
             GWRITE(x0*d);
             CWRITE(',');
             GWRITE(y0*d);
             SWRITE("){\\line(");
             GWRITE(t);
             CWRITE(',');
             GWRITE(y1-y0);
             SWRITE("){");
             GWRITE(d);
             SWRITE("}}\n");
             y1 = y1 + 2;
             }
           y0 = y0 + 2;
           }
         }
       SWRITE("\\end{picture}\n");
       SWRITE("\\end{figure}\n");

Step7: /* Report the computing time. */
       SWRITE("\\normalsize\n");
       SWRITE("\\begin{verbatim}\n");
       SWRITE("\nTime taken: ");
       GWRITE(T);
       SWRITE(" mill-seconds\n");
       SWRITE("\\end{verbatim}\n");

       SWRITE("\\end{document}\n");
       SWRITE("%=======================================================\n\n");

Return: /* Prepare for return. */
       return;
}







