/*======================================================================
                      C <- CREAD()

Character read.  (Replaces the saclib CREAD.)

Outputs
  C : the next character from the input stream.

Side effects
  LASTCHAR : set to the character C, for backspacing.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"
#include <stdio.h>

Word CREAD()
{
       Word C;
       /* hide algorithm */

Step1: /* If there was backspace. */
       if (! WASBKSP) goto Step2;
       C = LASTCHAR;
       WASBKSP = 0;
       goto Return;

Step2: /* Get a new character. */
       C = getc(INSTREAM);

Step3: /* End of file. */
       if (C == EOF)
         {
         fprintf(stderr,"\007\007\007");
         fclose(INSTREAM);
         fclose(OUTSTREAM);
         INSTREAM = fopen("/dev/tty","r");
         OUTSTREAM = fopen("/dev/tty","w");
         ECHO = 0;
         C = getc(INSTREAM);
         }

Step4: /* Remember the character. */
       LASTCHAR = C;

Step5: /* If requested, echo. */
       if (ECHO) putc(C,OUTSTREAM);

Step6: /* Keep it in the IBUFF. */
       IPOS = (IPOS + 1) % ISIZE;
       IBUFF[IPOS] = C;

Return: /* Prepare for return. */
       return(C);
}

