/*======================================================================
                      INITCTRL()

Initialize Program/Trace Control.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

void INITCTRL()
{
       Word k;
       /* hide k; */

Step1: /* Initialize Program Control Variables. */
       PCDBUSE = 'y';
       PCDBLIMIT = 500;
       PCPROJOP = NIL; 
       for (k = GVNV; k >= 2; k--)
         if (k == 2)
           PCPROJOP = COMP('c',PCPROJOP);
         else if (k == 3)
           PCPROJOP = COMP('m',PCPROJOP);
         else 
           PCPROJOP = COMP('h',PCPROJOP);
       PCCCS = LIST3(TCORD,LDORD,HLORD);
       PCCCSF = LIST1(LLORD);
       PCIGS = 'r';
       PCFINISH = 'n';
       PCNSTEP = 1;
       PCMC = 'n';
       PCTCN = 'y';
       PCRSP = 'y';
       PCFULL = 'n';
       PCDESIRED = LIST3(EQOP,0,0);
       PCUSEDES  = 'n';
       PCIPFZT = 'y';
       PCNUMDEC = 10;
       PCSIMPLIFY = 'b';
       PCEQC  = 0;

       PCRESALG = MODULAR;
       PCPROPEC = FALSE;

       PCSEARCHOK = 'n';
       PCSEARCHTRUE = 'n';
       PCSEARCHFALSE = 'n';


Step2: /* Initialize Algorithm Trace Control Variables. */
       TCPROJ = NIL;
       TCIPLFAC = NIL;

Step3: /* Initialize Data Trace Control Variables. */
       TCPC = 'n';
       TCPROD = 'n';
       TCPIMP = 'n';
       TCPIMPTBL = 'n';
       TCEPIMP = 'n';
       TCSTAT = 'y';
       TCDSTAT = 'n';

Return: /* Prepare for return. */
       return;
}
