                     QEPCAD(F*;t,Fe,Fn,Fs)

[Quantifier Elimination by Partial Cylindrical Algebraic Decomposition.
 
\Input
  \parm{F*} $=(Q_{f+1} x_{f+1})\cdots(Q_r x_r)\hat{F}(x_1,\ldots,x_r)$,
            $0\leq f < r$, is a quantified formula.
 
\Output
  \parm{t}  is either \c{EQU} or \c{INEQU}.
  \parm{Fe} is a quantifier-free formula equivalent to~\v{F*}
            if \v{t} is \c{EQU}, otherwise \v{Fe} is undefined.
  \parm{Fn} is a quantifier-free formula necssary for~\v{F*}
            if \v{t} is \c{INEQU}, otherwise \v{Fn} is undefined.
  \parm{Fs} is a quantifier-free formula sufficient for~\v{F*}
            if \v{t} is \c{INEQU}, otherwise \v{Fs} is undefined.
]

include "qepcadGlobals.h"

(1) [Normalize.]  
    FIRST4(F*;r,f,Q,F^); F := NORMQFF(F^); 
    if TYPEQFF(F) /= UNDET then {t := EQU; Fe := F; return}.

(2) [Projection.]
    A:=EXTRACT(r,F); 
    P:=PROJECT(r,A).

(3) [Truth-invariant CAD.]
    D:=TICAD(Q,F,f,P,A).
 
(4) [Solution.]
    SOLUTION(D,F,P,f;t,Fe,Fn,Fs)||

