/*******************************************************/
/*    qepcad.c  (global variables)                     */
/*******************************************************/
typedef int Word;
#include <stdio.h>

/* -----------------------------------------------*/
/*            Data-bases                          */
/* -----------------------------------------------*/
Word DBAFCSBM;      /* Database for AFCSBM */   
Word DBAFPNIP;      /* Database for AFPNIP */
Word DBAFUPGC;      /* Database for AFUPGC */
Word DBAFUPSFN;     /* Database for AFUPSFN */
Word DBFNDTS;       /* Database for FNDTS */
Word DBGETRP;       /* Database for GETRP */
Word DBMODCR;       /* Database for MODCR */
Word DBIPFAC;       /* Database for IPFAC */
Word DBTIME;        /* Atcuall computation begin time */
Word DBINFO;        /* Info of the item found */


/* ------------------------------------------------------------------------*/
/*                              Commmand                                   */
/* ------------------------------------------------------------------------*/
Word COMMANDS;     /* Holds Info about commands */
Word COMCLASS;     /* Holds command classifications and descriptions. */
#define MaxNumCommands         100
char               *Helps[MaxNumCommands];


/* ------------------------------------------------------------------------*/
/*                          Intermediate results                           */
/* ------------------------------------------------------------------------*/
Word GVVL;         /* Variable List */
Word GVF;          /* Input Formula */
Word GVQ;          /* Quantifier List */
Word GVQFF;        /* Quantifier-free formula part of the input */
Word GVNQFF;       /* Normalized quantifier-free formula part */
Word GVNIP;        /* Input Normalized Polynomials */
Word GVLV;         /* Current Level */
Word GVPF;         /* Projection Factors */
Word GVPJ;         /* Projection Polynomials */
Word GVPC;         /* Current Partial CAD */
Word GVNV;         /* Number of variables */
Word GVNFV;        /* Number of Free Variables */
Word GVMCOMM;      /* Main comment. */

Word GVEQNCONST;   /* Equational constraints. */
Word GVPIVOT;      /* List of pivot constraints at each level. */


/* ------------------------------------------------------------------------*/
/*                     Algorithm  trace control                             */
/* ------------------------------------------------------------------------*/
Word TCPROJ;   /* Projection Operation */
Word TCIPLFAC; /* Complete Factorization */


/* ------------------------------------------------------------------------*/
/*                    Data trace control                                   */
/* ------------------------------------------------------------------------*/
Word TCPC;      /* Partial CAD */
Word TCPROD;    /* Product generated */
Word TCPIMP;    /* Prime Implicant */
Word TCPIMPTBL; /* Prime Implicant Table */
Word TCEPIMP;   /* Essential Prime Implicant */ 
Word TCSTAT;    /* Statistics at the end */
Word TCDSTAT;   /* Dissertation statistics at the end */


/* ------------------------------------------------------------------------*/
/*                      Program control                                    */
/* ------------------------------------------------------------------------*/
Word PCNSTEP;        /* Number of steps to be skipped */
Word PCFINISH;       /* 'y' if finish, 'n' otherwise */
Word PCMC;           /* 'y' if a cell is  chosen manually, 'n' otherwise */
Word PCMCC;          /* The cell manually chosen */
Word PCTCN;          /* 'y' if trivial conversion is treated, 'n' otherwise */
Word PCRSP;          /* 'y' if rational sample point is treated, 'n' otherwise */
Word PCFULL;         /* 'y' if a full CAD is to be build */
Word PCDBUSE;        /* 'y' if Databases are used 'n' otherwise */
Word PCDBLIMIT;      /* Limit for Database Entry */
Word PCPROJOP;       /* Projection operators */       
Word PCCCS;          /* Cell Choice Strategy for cells of level >= f.*/
Word PCCCSF;         /* Cell Choice Strategy for cells of level < f. */
Word PCIGS;          /* Implicant Generation Strategy */
Word PCDESIRED;      /* Desired cell condition */
Word PCUSEDES;       /* 'y' if use the desired condition, 'n' otherwise. */
Word PCIPFZT;        /* 'y' if IPFZT is turned on, 'n' otherise. */
Word PCNUMDEC;       /* Number of decimal digits for approximating algebraic  numbers. */
Word PCSIMPLIFY;     /* 'b' if bottom-up is used.  't' if top-down is used. */
Word PCEQC;          /* 1 if equantional constraint specified. 0 otherwise. */

Word PCRESALG;       /* MODULAR or SUBRES.  Algorithm to use for resultant
			and discriminant computation. */
Word PCPROPEC;       /* Propagation of equational constraints. TRUE or FALSE */

Word PCSEARCHOK;     /* 'y' if the search for true/false cell succeeded, 'n' otherwise. */
Word PCSEARCHTRUE;   /* 'y' if the search for true cell should be done, 'n' otherwise. */
Word PCSEARCHFALSE;  /* 'y' if the search for false cell should be done, 'n' otherwise. */



/* ------------------------------------------------------------------------*/
/*                         Statistics                                      */
/* ------------------------------------------------------------------------*/
#define MNV    30  /* Maximum Number of Variables = 30 */
#define MNV1   31  /* One more for C arrary. */

/* Statictics on QEPCAD */
Word BTMQEPCAD;     /* Time at which QECAD was called */

/* Statistics on Normalization Phase */
Word TMNORMQFF;     /* Time for Normalization Phase, NORMQFF */

/* Statistics on Projection Phase */
Word TMPROJECT[MNV1];   /* Time for Projection Phase, PROJECT */
Word   TMPROJ[MNV1];       /* Time for Projection Operation,  PROJ */
Word     TMIPFZT[MNV1];      /* Time for Finite Zero Test, IPFZT */
Word   TMIPLFAC[MNV1];     /* Time for Complete Factorization, IPLFAC */
Word   TMAPPEND[MNV1];     /* Time for Appending, APPEND */

/* Statistics on Truth Invariant CAD Construction Phase */
Word TMTICAD[MNV1];     /* Time for Truth invariant CAD Construnction Phase, TICAD */
Word   TMCHOOSE[MNV1];    /* Time for Choosing a cell, CHOOSE */
Word   TMCONVERT[MNV1];   /* Time for Conversion, CONVERT */
Word     TMTCN[MNV1];       /* Time for Trivial Conversion */
Word     TMNORMAL[MNV1];    /* Time for NORMAL, NORMAL */
Word     TMSIMPLE[MNV1];    /* Time for SIMPLE, SIMPLE */
Word   TMCONSTRUCT[MNV1]; /* Time for stack construction, CONSTRUCT */
Word     TMSUBST[MNV1];     /* Time for substituting on irrational sample point, SUBST */
Word     TMAFUPLM[MNV1];    /* Time for computing ldcf and monic associates, AFUPLM */
Word     TMAFCSBM[MNV1];    /* Time for computing coarsest squarefree basis, AFCSBM */
Word     TMAFPBRI[MNV1];    /* Time for isolating real roots of algebraic polys, AFUPBRI */
Word     TMEC[MNV1];        /* Time for establishing children on irration, EC */
Word     TMSIGNP[MNV1];     /* Time for computing projection signatures, SIGNP */
Word     TMRCFAFC[MNV1];    /* Time for converting to rational polynomials, RCFAFC */
Word     TMSUBSTR[MNV1];    /* Time for substituting on rational sample point, SUBSTR */
Word     TMIPLSRP[MNV1];    /* Time for computing signs and similar int; polys, IPLSRP */
Word     TMIPFSBM[MNV1];    /* Time for computing finest squarefree basis, IPFSBM */
Word     TMIPLRRI[MNV1];    /* Time for integral poly real root isolation,  IPLRRI */
Word     TMECR[MNV1];       /* Time for establishing children on rational, ECR, EC1 */
Word     TMSIGNPR[MNV1];    /* Time for computing projection signature, SIGNPR, SIGNP1 */  
Word   TMEVALUATE[MNV1];  /* Time for trial evaluataion, EVALUATE */
Word   TMPROPAGATE[MNV1]; /* Time for propagation, PROPAGATE */
Word   TMAPEQC[MNV1];     /* Time for applying equational constraints, APEQC */

/* Statistics on Solution Formula Construction Phase */
Word TMSOLUTION;      /* Time for Solution Formula Construction Phase */
Word   TMSIGTBL;        /* Time for building signature tables, SIGTBL */
Word   TMSIGINS;        /* Time for computing the signature intersection, SIGINS */
Word   TMMVLMASF;       /* Time for MVLMA, MVLMASF */
Word     TMGENIMP;        /* Time for generating implicants, GENIMP */
Word     TMSELIMP;        /* Time for selecting implicants, SELIMP */

/* Statatics, Counting */
Word NMNIP[MNV1];      /* Number of normalized input polynomials */
Word NMPF[MNV1];       /* Number of projection factors */
Word NMPJ[MNV1];       /* Number of projection polynomials */
Word NMSTACK[MNV1];    /* Number of Stacks */
Word NMSTACKR[MNV1];   /* Number of Stack over a Rational sample point */
Word NMCELL[MNV1];     /* Number of Cells */
Word NMCONVERT[MNV1];  /* Number of Conversion */
Word NMTCONVERT[MNV1]; /* Number of Trivial Conversion */
Word NMFPF;            /* Number of Projection factors of level <= f */
Word NMPRPT;           /* Number of propgation solution signatures */
Word NMPRPF;           /* Number of propagation non-solution signatures */
Word NMPRPC;           /* Number of compatible propagation signatures */
Word NMGENPRD;         /* Number of products generated */
Word NMGENIMP;         /* Number of implicants generated */
Word NMSELIMP;         /* Number of implicants selected */
Word NMATOM;           /* Number of atomic formulas in the solution qff */

/* Statistics on Databases */
Word TMDBMNG;     /* Time for Database management */
Word TMDBSAV;     /* Time Saved by using databases */


/* ------------------------------------------------------------------------*/
/*                          Input and output                               */
/* ------------------------------------------------------------------------*/
#define ISIZE  70
char IBUFF[ISIZE];    /* The size of input buffer for errory display. */
Word  IPOS;           /* The position of the last character read. */
Word  OPOS;           /* The position of the last character written. */
Word  ECHO;           /* Echo the input if 1. */
Word  WASBKSP;        /* 1 if there was backspace. */
FILE *INSTREAM;       /* Input stream. */
FILE *OUTSTREAM;      /* Output stream. */



/* -------------------------------------------------------------------------*/
/*                     Report the global variables to GC.                   */
/* -------------------------------------------------------------------------*/
void QEGLOBALS()
{
  extern void GCGLOBAL();

  GCGLOBAL(&DBAFCSBM);     /* Database for AFCSBM */   
  GCGLOBAL(&DBAFPNIP);     /* Database for AFPNIP */
  GCGLOBAL(&DBAFUPGC);     /* Database for AFUPGC */
  GCGLOBAL(&DBAFUPSFN);    /* Database for AFUPSFN */
  GCGLOBAL(&DBFNDTS);      /* Database for FNDTS */
  GCGLOBAL(&DBGETRP);      /* Database for GETRP */
  GCGLOBAL(&DBMODCR);      /* Database for MODCR */
  GCGLOBAL(&DBIPFAC);      /* Database for IPFAC */
  GCGLOBAL(&DBINFO);       /* Info of the item found */
  GCGLOBAL(&COMMANDS);     /* Holds Info about commands */
  GCGLOBAL(&COMCLASS);     /* Holds command classifications and descriptions. */

  GCGLOBAL(&GVVL);         /* Variable List */
  GCGLOBAL(&GVF);          /* Input Formula */
  GCGLOBAL(&GVQ);          /* Quantifier List */
  GCGLOBAL(&GVQFF);        /* Quantifier-free formula part of the input */
  GCGLOBAL(&GVNQFF);       /* Normalized quantifier-free formula part */
  GCGLOBAL(&GVNIP);        /* Input Normalized Polynomials */
  GCGLOBAL(&GVLV);         /* Current Level */
  GCGLOBAL(&GVPF);         /* Projection Factors */
  GCGLOBAL(&GVPJ);         /* Projection Polynomials */
  GCGLOBAL(&GVPC);         /* Current Partial CAD */
  GCGLOBAL(&GVMCOMM);      /* Main comment. */
  GCGLOBAL(&TCPROJ);       /* Projection Operation */
  GCGLOBAL(&TCIPLFAC);     /* Complete Factorization */
  GCGLOBAL(&PCMCC);        /* The cell manually chosen */
  GCGLOBAL(&PCPROJOP);     /* Projection operators */     
  GCGLOBAL(&PCCCS);        /* Cell Choice Strategy for cells of level >=f. */
  GCGLOBAL(&PCCCSF);       /* Cell Choice Strategy for cells of level < f. */
  GCGLOBAL(&PCIGS);        /* Implicant Generation Strategy */
  GCGLOBAL(&PCDESIRED);    /* Desired cell condition */

  GCGLOBAL(&GVEQNCONST);   /* Equational constraints. */
  GCGLOBAL(&GVPIVOT);      /* List of pivot constraints at each level. */
}
