/*======================================================================
                      TRPIMPTBL(M,Nc,Nr)

Trace "PIMPTBL".
======================================================================*/
#include "saclib.h"
#include "qepcad.h"
#define ALIVE      0
#define DEAD       1
#define ESSENTIAL  2

void TRPIMPTBL(M,Nc,Nr)
       MarksTable M;
       Word Nc,Nr;
{
       Word i,j;
 
Step1: /* Draw the column heading. */
       if (Nc >= 1000 || Nr >= 1000)
         { SWRITE("PIMPTBLWR: Sorry the table is too big.\n"); goto Return; }
       SWRITE("=======");
       for (j = 1; j <= Nc; j++)
         { if (M[0][j] == ALIVE) CWRITE('='); }
       SWRITE("\n       ");
       for (j = 1; j <= Nc; j++)
         { if (M[0][j] == ALIVE) { d = j / 100; CWRITE(d + '0'); } }
       SWRITE("\n       ");
       for (j = 1; j <= Nc; j++)
         { if (M[0][j] == ALIVE) { d = REM(j,100) / 10; CWRITE(d + '0'); } }
       SWRITE("\n       ");
       for (j = 1; j <= Nc; j++)
         { if (M[0][j] == ALIVE) { d = REM(j,10); CWRITE(d + '0'); } }
       SWRITE("\n       ");
       for (j = 1; j <= Nc; j++)
         { if (M[0][j] == ALIVE) CWRITE('-'); }
       SWRITE("\n");

Step2: /* Draw each rows. */
       for (i = 1; i <= Nr; i++)
         {
         if (M[i][0] != ALIVE) continue;
         TAB(3); GWRITE(i); TAB(6); CWRITE('|');
         for (j = 1; j <= Nc; j++)
           {
           if (M[0][j] != ALIVE) continue;
           if (M[i][j] == 1)
             CWRITE('X');
           else
             CWRITE('.');
           }
         SWRITE("\n");
         }

Step3: /* Draw the final line. */
       SWRITE("=======");
       for (j = 1; j <= Nc; j++)
         { if (M[0][j] == ALIVE) CWRITE('='); }
       SWRITE("\n");

Return: /* Prepare for return. */
       return;
}
