/*======================================================================
                      n <- CATOMQFF(F)

Count  the number of atomic formula in Qff.

\Input
  \parm{F} is a quantifer-free formula.

\Output
  \parm{n} is the number of occurrences of atomic formulas.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

Word CATOMQFF(F)
       Word F;
{
       Word F1,n;
       /* hide n; */

Step1: /* Atomic Formula. */
       if (ISATOMF(F)) { n = 1; goto Return; }

Step2: /* Non-atomic formula. */
       F = RED(F); n = 0;
       while (F != NIL)
         {
         ADV(F,&F1,&F);
         n = n + CATOMQFF(F1);
         }
       goto Return;

Return: /* Prepare for return. */
       return(n);
}
