/*======================================================================
                      FIRSTPRD(n; v,S_r,S_s,R_c,R_s)

First Product.

\Input
  \parm{n}   is the number of variables.
   
\Output
  \parm{v}  is the first product.
  \parm{Sr} is the slot arragment for relational operators.
  \parm{Ss} is the slot arrgement for strict relational operators.
  \parm{Rc} is the compound relational operators arrangement.
  \parm{Rs} is the strict relational operators arrangement.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

void FIRSTPRD(n, v_,S_r_,S_s_,R_c_,R_s_)
       Word n, *v_,*S_r_,*S_s_,*R_c_,*R_s_;
{
       Word R_c,R_s,S_r,S_s,i,v;
       /* hide i; */

Step1: /* Make it. */
       v = NIL; for (i = 1; i <= n; i++) v = COMP(TAOP,v);
       S_r = NIL; S_s = NIL; R_c = NIL; R_s = NIL;

Return: /* Prepare for return. */
       *v_ = v;
       *S_r_ = S_r;
       *S_s_ = S_s;
       *R_c_ = R_c;
       *R_s_ = R_s;
       return;
}
