/*======================================================================
                    W <- LENPROJF(P,f)

Number of Projection factors of level less than f.
 
\Input
  \parm{P} is the projection factors.
  \parm{f} is the number of free variables.
 
\Output
  \parm{W} is the number of projection factors of level less than f.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

Word LENPROJF(P,f)
       Word P,f;
{
       Word W,P1,i;

Step1: /* Count. */
       W = 0;
       for (i=1; i<=f; i++)
         {
         ADV(P,&P1,&P);
         W = W + LENGTH(P1);
         }

Return: /* Prepare for return. */
       return (W);
}



