/*======================================================================
                   R <- RELFSIGN(S)

Relational Operator from Sign
 
\Input
  \parm{S} is a sign (NEGATIVE, ZERO, POSITIVE).
 
\Output
  \parm{R} is the corresponding relational operator (LTOP, EQOP, GTOP).
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

Word RELFSIGN(S)
       Word S;
{
       Word R;

Step1: /* Translate. */
       switch(S) 
	 {
         case NEGATIVE: R = LTOP; break;
         case ZERO:     R = EQOP; break;
         case POSITIVE: R = GTOP; break;
         }

Return: /* Prepare for return. */
       return (R);
}



