/*======================================================================
                      RMDUPA(T,L,W; L')

Remove Duplicates (array version).
 
\Input
  \parm{T} is an array.
  \parm{L} is the length of the array.
  \parm{W} is the length of the array element.
 
\Output
  \parm{T} is obtained from T by remove the duplicates.
  \parm{L'} is the length of the resulting array.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"
#include <stdlib.h>

void RMDUPA(T,L,W,Lp_)
       Word L,W,*Lp_;
       RelOpsTable T;
{
       Word Lp,i,j;

Step1: /* Clear Marks. */
       for (i = 1; i <= L; i++)
         T[i][0] = 0; 

Step2: /* Mark the duplicates. */
       for (i = 1; i <= L-1; i++)
         if (T[i][0] == 0)
           {
           for (j = i + 1; j <= L; j++) 
             if (T[j][0] == 0)             
               if (SAMERELOPS(W,T[i],T[j]))
                  T[j][0] = 1;
           } 

Step3: /* Compact. */
       Lp = 0;
       for (i = 1; i <= L; i++)
         if (T[i][0] == 0) 
           {
           Lp++;
           T[Lp] = T[i];
           }
         else
           free(T[i]);

Return: /* Prepare for return. */
       *Lp_ = Lp;
       return;
}



