/*======================================================================
                    N <- SIGINS(Tt,Tf,Lt,Lf,W)

Signaures Intersection
 
\Input
  \parm{Tt} is an array of signatures.
  \parm{Tf} is an array of signatures.
  \parm{Lt} is the length of Tt.
  \parm{Lf} is the length of Tf.
  \parm{W} is the length of a signature.

 
\Output
  \parm{N}  is the number of common signaures.
  \parm{Tt} is modified so that the common signatures are marked.
  \parm{Tf} is modified so that the common signatures are marked.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

Word SIGINS(T_t,T_f,L_t,L_f,W)
       Word L_t,L_f,W;
       RelOpsTable T_t,T_f;
{
       Word N,i,j;

Step1: /* Clear the marks. */
       for (i = 1; i <= L_t; i++)
         T_t[i][0] = 0;
       for (i = 1; i <= L_f; i++)
         T_f[i][0] = 0;

Step2: /* Mark the common ones. */
       N = 0;
       for (i = 1; i <= L_t; i++)
         for (j = 1; j <= L_f; j ++)
           {
           if (SAMERELOPS(W,T_t[i],T_f[j]))
             T_t[i][0] = 1;
             T_f[j][0] = 1;
             N++;
             break;
           }

Return: /* Prepare for return. */
       return (N);
}



