/*======================================================================
                      Jp <- GROUPSAMEPJ(r,J)

Group the same projection polynomials.

\Input
  \parm{r} is the positive BETA-integer.
  \parm{J} is a list of polynomial in r variables.

\Output
  \parm{J'} is the list such that same elements are grouped.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

Word GROUPSAMEPJ(r,J)
       Word r,J;
{
       Word J1,Jp,Js,t, Js1, Jt, J2, Jt2, i;

Step1: /* Group. */
       Jp = NIL; Js = J;
       i = 0;
       while (Js != NIL)
         {
         ADV(Js,&J1,&Js);
         Js1 = LELTI(J1,PO_POLY);
	 Jt = Jp;
         t = 0;
         while (Jt != NIL)
           {
           ADV(Jt,&J2,&Jt);
           Jt2 = LELTI(J2,PO_POLY);
           if (EQUAL(Js1,Jt2))
             {
             SLELTI(J2,PO_PARENT,CONC(LELTI(J2,PO_PARENT),LELTI(J1,PO_PARENT)));
             t = 1;
             break;
             }
           }
         if (t == 0)
           {
           i = i + 1;
           SLELTI(J1,PO_LABEL,LIST3(LFS("J"),r,i));
           Jp = COMP(J1,Jp);
           }
         }
       Jp = INV(Jp);

Return: /* Prepare for return. */
       return(Jp);
}
