/*======================================================================
                      FILLIN(n,vs,S_r,S_s,R_c,R_s; v)

Fill in the slots with relational operators.

\Input
  \parm{n}  is the number of variables.
  \parm{v*} is a product.
  \parm{Sr} is the slot arragment for relational operators.
  \parm{Ss} is the slot arrgement for strict relational operators.
  \parm{Rc} is the compound relational operators arrangement.
  \parm{Rs} is the strict relational operators arrangement.

\Output
  \parm{v} is the next product.

\Side
  \parm{v*} is modified.
  
  The step 1, 2, and 3 are very inefficient. Need to be refined!
======================================================================*/
#include "saclib.h"
#include "qepcad.h"
#define CMPN      -1
#define STRT      -2

void FILLIN(n,vs,S_r,S_s,R_c,R_s, v_)
       Word n,vs,S_r,S_s,R_c,R_s, *v_;
{
       Word R1,Rp_c,Rp_s,Sp_r,Sp_s,i,j,v,v1,vp;

Step1: /* Mark every location with TAOP. */
       vp = vs;
       while (vp != NIL)
         {
         SFIRST(vp,TAOP);
         vp = RED(vp);
         }

Step2: /* Mark the relational operator slot. */
       Sp_r = S_r;
       while (Sp_r != NIL)
         {
         ADV(Sp_r,&i,&Sp_r);
         if (PCIGS == 'l')
           SLELTI(vs,i,CMPN);
         else
           SLELTI(vs,n + 1 - i,CMPN);
         }

Step3: /* Mark the strict operator slot. */
       Sp_s = S_s;
       while (Sp_s != NIL)
         {
         ADV(Sp_s,&j,&Sp_s);
         i = LELTI(S_r,j);
         if (PCIGS == 'l')
           SLELTI(vs,i,STRT);
         else
           SLELTI(vs,n + 1 - i,STRT);
         }

Step4: /* Fill in the slots. */
       vp = vs; Rp_c = R_c; Rp_s = R_s;
       while (vp != NIL)
         {
         v1 = FIRST(vp);
         switch (v1)
           {
           case TAOP: break;
           case CMPN:
                {
                ADV(Rp_c,&R1,&Rp_c);
                switch (R1)
                  {
                  case 0: SFIRST(vp,GEOP); break;
                  case 1: SFIRST(vp,NEOP); break;
                  case 2: SFIRST(vp,LEOP); break;
                  }
                } break;
           case STRT:
                {
                ADV(Rp_s,&R1,&Rp_s);
                switch (R1)
                  {
                  case 0: SFIRST(vp,GTOP); break;
                  case 1: SFIRST(vp,EQOP); break;
                  case 2: SFIRST(vp,LTOP); break;
                  }
                } break;
           }
         vp = RED(vp);
         }
       v = vs;
       goto Return;

Return: /* Prepare for return. */
       *v_ = v;
       return;
}
