/*======================================================================
                      H <- MVLMASF(H_t,H_f)

Multiple-Valued Logic Minimization Algorithm, Shorter product First.
 
\Input
  \parm{Ht} is a sum-of-product.
  \parm{Hf} is a sum-of-product.
            They togather define a logic function~$L$.
          
\Output
  \parm{H}  is a ``simple'' cover of $L$.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

Word MVLMASF(H_t,H_f)
       Word H_t,H_f;
{
       Word H,P,Ths,Thss,V,m;
       /* hide Ths,Thss,m; */

Step1: /* Implicants. */
                                /*Int*/ Thss = ACLOCK();
                                /*Int*/ Ths = Thss;
       P = GENPIMP(H_t,H_f);
                                /*Int*/ Ths = ACLOCK() - Ths;
                                /*Int*/ TMGENIMP = Ths;

Step2: /* Select. */
                                /*Int*/ Ths = ACLOCK();
       FIRST2(P,&m,&V);
       H = SELPIMP(m,V);
                                /*Int*/ Ths = ACLOCK() - Ths;
                                /*Int*/ TMSELIMP = Ths;
                                /*Int*/ Thss = ACLOCK() - Thss;
                                /*Int*/ TMMVLMASF = Thss;
       goto Return;

Return: /* Prepare for return. */
       return(H);
}
