/*======================================================================
                      NEXTLEXI(l,Rs; R,q)

Next element in Lexicographic order.

\Input
  \parm{l} is the length of the element.
  \parm{R*} is an element.

\Output
  \parm{R} is the element if successful.
  \parm{q} is 1 if successful, 0 otherwise.

\Side
  \parm{R*} is modified.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

void NEXTLEXI(l,Rs, R_,q_)
       Word l,Rs, *R_,*q_;
{
       Word R,R1,Rp,q;
       /* hide q; */

Step1: /* Determine the last updatable digit. */
       R = Rs;
       R = INV(R);
       Rp = R;
       while (Rp != NIL)
         {
         R1 = FIRST(Rp);
         if (R1 < 2) goto Step2;
         Rp = RED(Rp);
         }
       q = 0; goto Return;

Step2: /* Update. */
       R = INV(R);
       SFIRST(Rp,R1 + 1);
       Rp = RED(Rp);
       while (Rp != NIL)
         {
         SFIRST(Rp,0);
         Rp = RED(Rp);
         }
       q = 1; goto Return;

Return: /* Prepare for return. */
       *R_ = R;
       *q_ = q;
       return;
}
