/*======================================================================
                      EVALUATE(c,k,F,A)

Evaluate the truth values, trial.

\Input
  \parm(c} is a cell.
  \parm{k} is the level of the cell~$c$.
  \parm{F} is the normalized quantifier-free part of the input formula.
  \parm{A} is the list~$(A_1,\ldots,A_r)$,
            where $A_i = (A_{i,1},\ldots,A_{i,n_i})$ is the list
            of all the distinct $i$--level polynomials in~$F$.
                
\Output
  The truth values of some cells in the stack over
  the cell~$c$ are  determined, if possible.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

void EVALUATE(c,k,F,A)
       Word c,k,F,A;
{
       Word cb,cs,t;

Step1: /* Unhelpful case. */
       if (LELTI(A,k + 1) == NIL) goto Return;

Step2: /* Evaluate. */
       cb = LELTI(c,CHILD);
       while (cb != NIL)
         {
         ADV(cb,&cs,&cb);
         t = QFFTEV(F,cs,k + 1);
         if (t != UNDET)
           { 
           SLELTI(cs,TRUTH,t); 
           SLELTI(cs,HOWTV,BYTEV); 
                               /*Int*/ if (PCSEARCHTRUE == 'y' && t == TRUE)
                               /*Int*/   { 
                               /*Int*/   SWRITE("****** True cell ******\n");
                               /*Int*/   CELLWR(cs);
                               /*Int*/   PCSEARCHOK = 'y';
                               /*Int*/   }
                               /*Int*/ if (PCSEARCHFALSE == 'y' && t == FALSE)
                               /*Int*/   { 
                               /*Int*/   SWRITE("****** False cell *****\n ");
                               /*Int*/   CELLWR(cs);
                               /*Int*/   PCSEARCHOK = 'y';
                               /*Int*/   }
           }
         }

Return: /* Prepare for return. */
       return;
}

