/*======================================================================
                      NEXTCELL(D,c; cp,t)

Next Cell.

\Input
   \parm{D} is a partial CAD.
   \parm{c} is a cell in D.

\Ouput
   \parm{c'} is the cell next to $c$ in depth first order.
   \parm{t}  is 1 if there is a next cell, 0 otherwise.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

void NEXTCELL(D,c, cp_,t_)
       Word D,c, *cp_,*t_;
{
       Word cb,ch,cp,cs,k,t;
       /* hide t; */

Step1: /* If c has children. */
       cb = LELTI(c,CHILD);
       if (cb != NIL) { cp = FIRST(cb); t = 1; goto Return; }
       ch = c;

Step2: /* If c^ is the root cell. */
       if (LELTI(ch,LEVEL) == 0) { t = 0; goto Return; }

Step3: /* If c^ has a brother on the right. */
       cs = DESCENDANT(D,LELTI(ch,INDX),LELTI(ch,LEVEL)-1); 
       cb = LELTI(cs,CHILD);
       k = FIRST(LASTCELL(LELTI(ch,INDX)));
       if (k < LENGTH(cb)) { cp = LELTI(cb,k + 1); t = 1; goto Return; }

Step4: /* Loop. */
       ch = cs; goto Step2;

Return: /* Prepare for return. */
       *cp_ = cp;
       *t_ = t;
       return;
}
