/*======================================================================
                      SIGNP1(c,P1,I)

Signatures of Projection factors, $1$--level.
 
\Input
  \parm{c}  is the root cell.
  \parm{P1} is the list of the $1$--level projection factors.
  \parm{I}  is a list of the real roots of $P_1$.
 
\Output
  The signatures of~$P_1$ on the cells 
  in the stack over the root cell~$c$
  are determined and attached to them.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

void SIGNP1(c,P1,I)
       Word c,P1,I;
{
       Word S,S1,c1,cb;

Step1: /* Compute the signatures of $P_1$. */
       S = SIGNB(P1,I);

Step2: /* Attach the signatures to the cells. */
       cb = LELTI(c,CHILD);
       while (cb != NIL)
         {
         ADV(cb,&c1,&cb); ADV(S,&S1,&S);
         SFIRST(LELTI(c1,SIGNPF),S1);
         }
       goto Return;

Return: /* Prepare for return. */
       return;
}
