/*======================================================================
                      TCHILD(c; A1,A0,E1,E0)

Test the truth value of the children.

\Input
  \parm{c} is a cell.

\Output
  \parm{A1} is 1 if all children are true, 0 otherwise.
  \parm{A0} is 1 if all children are false, 0 otherwise.
  \parm{E1} is 1 if there exists a true child, 0 otherwise.
  \parm{E0} is 1 if there exists a false child, 0 otherwise.
======================================================================*/
#include "saclib.h"
#include "qepcad.h"

void TCHILD(c, A1_,A0_,E1_,E0_)
       Word c, *A1_,*A0_,*E1_,*E0_;
{
       Word A0,A1,E0,E1,cb,cp,t;
       /* hide A0,A1,E0,E1; */

Step1: /* Setup. */
       cb = LELTI(c,CHILD);
       A1 = 1; A0 = 1; E1 = 0; E0 = 0;

Step2: /* Check. */
       while (cb != NIL)
         {
         ADV(cb,&cp,&cb);
         t = LELTI(cp,TRUTH);
         if (t == TRUE) { E1 = 1; A0 = 0; }
         if (t == FALSE) { E0 = 1; A1 = 0; }
         if (t == UNDET) { A0 = 0; A1 = 0; }
         }
       goto Return;

Return: /* Prepare for return. */
       *A1_ = A1;
       *A0_ = A0;
       *E1_ = E1;
       *E0_ = E0;
       return;
}
